Subject: Re: taprio testing - Any help?

From: Vinicius Costa Gomes <[email-masked]>
Date: Fri, 11 Oct 2019 13:12:08 -0700

Hi Murali,

Murali Karicheri <[email-masked]> writes:

> Hi,
>
> I am testing the taprio (802.1Q Time Aware Shaper) as part of my
> pre-work to implement taprio hw offload and test.
>
> I was able to configure tap prio on my board and looking to do
> some traffic test and wondering how to play with the tc command
> to direct traffic to a specfic queue. For example I have setup
> taprio to create 5 traffic classes as shows below;-
>
> Now I plan to create iperf streams to pass through different
> gates. Now how do I use tc filters to mark the packets to
> go through these gates/queues? I heard about skbedit action
> in tc filter to change the priority field of SKB to allow
> the above mapping to happen. Any example that some one can
> point me to?

What I have been using for testing these kinds of use cases (like iperf)
is to use an iptables rule to set the priority for some kinds of traffic.

Something like this:

sudo iptables -t mangle -A POSTROUTING -p udp --dport 7788 -j CLASSIFY --set-class 0:3

This will set the skb->priority of UDP packets matching that rule to 3.

Another alternative is to create a net_prio cgroup, and the sockets
created under that hierarchy would have have that priority. I don't have
an example handy for this right now, sorry.

Is this what you were looking for?

Cheers,
--
Vinicius